/* Abstraction of GNU v3 abi.
   Contributed by Daniel Berlin <dberlin@redhat.com>
   Copyright 2001 Free Software Foundation, Inc.

   This file is part of GDB.

   This program is free software; you can redistribute it and/or
   modify
   it under the terms of the GNU General Public License as published
   by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include "defs.h"
#include "cp-abi.h"
#include "gdb_regex.h"
#include "gdb_string.h"
struct cp_abi_ops gnu_v3_abi_ops;
/* FIXME: Stop doing the re_comp's everytime. Use the other regex api
   and compile the patterns ahead of time */

int gnuv3_destructor_prefix_p (const char * name)
{
  re_comp ("[^0-9]D[1-3]Ev");
  return re_exec (name) != 0;
}

int gnuv3_constructor_prefix_p (const char * name)
{
  re_comp ("[^0-9]C[1-3]E");
  return re_exec (name) != 0;
}

int gnuv3_vtable_prefix_p (const char * name)
{
  return strncmp (name, "_ZTV", 4) != 0;
}
void
init_gnuv3_ops (void)
{
  gnu_v3_abi_ops.cpo_shortname = "gnu-v3";
  gnu_v3_abi_ops.cpo_longname = "GNU G++ Version 3 ABI";
  gnu_v3_abi_ops.cpo_doc = "G++ Version 3 ABI";
  gnu_v3_abi_ops.cpo_destructor_prefix_p = gnuv3_destructor_prefix_p;
  gnu_v3_abi_ops.cpo_constructor_prefix_p = gnuv3_constructor_prefix_p;
  gnu_v3_abi_ops.cpo_vtable_prefix_p = gnuv3_vtable_prefix_p;

}
/*struct cp_abi_ops current_cp_abi;*/
void
_initialize_gnu_v3_abi (void)
{
  init_gnuv3_ops();
 /* current_cp_abi = gnu_v3_abi_ops;*/
  
}

